use super::schema::api_kgon_synchronization_history;
use beteran_common_rust as bcr;
use diesel::deserialize::QueryableByName;

///
#[derive(Eq, Hash, Identifiable, Queryable, PartialEq, Debug, Clone)]
#[table_name = "api_kgon_synchronization_history"]
pub struct SynchronizationHistory {
  ///
  pub id: i64,
  ///
  pub item: String,
  ///
  pub start_at: i64,
  ///
  pub complete_at: i64,
  ///
  pub code: i64,
  ///
  pub message: Option<String>,
  ///
  pub data: Option<String>,
  ///
  pub created_at: i64,
}

///
#[derive(Insertable, Debug, Clone)]
#[table_name = "api_kgon_synchronization_history"]
pub struct NewSynchronizationHistory {
  ///
  pub item: String,
  ///
  pub start_at: i64,
  ///
  pub complete_at: i64,
  ///
  pub code: i64,
  ///
  pub message: Option<String>,
  ///
  pub data: Option<String>,
}

///
#[derive(Debug, Clone)]
pub struct FindAllSearch {
  ///
  pub item: Option<String>,
  ///
  pub code: Option<i64>,
}
///
#[derive(Debug, Clone)]
pub struct FindAll {
  pub search: Option<FindAllSearch>,
  ///
  pub pagination: Option<bcr::pagination::Pagination>,
  ///
  pub sorts: Option<Vec<bcr::pagination::Sort>>,
}

impl QueryableByName<diesel::pg::Pg> for SynchronizationHistory {
  fn build<R: diesel::row::NamedRow<diesel::pg::Pg>>(row: &R) -> diesel::deserialize::Result<Self> {
    Ok(SynchronizationHistory {
      id: row.get("id")?,
      item: row.get("item")?,
      start_at: row.get("start_at")?,
      complete_at: row.get("complete_at")?,
      code: row.get("code")?,
      message: row.get("message")?,
      data: row.get("data")?,
      created_at: row.get("created_at")?,
    })
  }
}
