use crate::compositions;
use beteran_protobuf_rust as bpr;

impl From<&compositions::betting::models::BettingHistoryModel>
  for bpr::models::api::betting::BettingHistory
{
  fn from(d: &compositions::betting::models::BettingHistoryModel) -> Self {
    bpr::models::api::betting::BettingHistory {
      id: d.id.clone(),
      vendor_id: d.vendor_id as u64,
      vendor_name: d.vendor_name.clone(),
      game_id: d.game_id as u64,
      game_name: d.game_name.clone(),
      game_category: d.game_category.clone(),
      game_type: d.game_type.clone(),
      currency: d.currency.clone(),
      cash: d.cash,
      before_cash: d.before_cash,
      after_cash: d.after_cash,
      group_key: d.group_key.clone(),
      detail: d.detail.clone(),
      is_bonus: d.is_bonus,
      is_promo: d.is_promo,
      is_jackpot: d.is_jackpot,
      site_username: d.site_username.clone(),
      key: d.key.clone(),
      ref_id: d.ref_id.clone(),
      o_ref_id: d.o_ref_id.clone(),
      betting_type: d.betting_type.clone(),
      category: d.category.clone(),
      created_at: d.created_at as u64,
      utc_created_at: d.utc_created_at as u64,
    }
  }
}
